
; BBRAM test, allows power to cycle, each time testing any BBRAM

NVRFLG	EQU	0F100H
NVRCTR	EQU	0F101H
NVRFAL	EQU	0F103H

ML	; load mem, ML TYPE; 1-55, 2-AA, 3-LSBY, others are bad
	CALL	SPACE1		; print a space
	CALL	CARG		; collect arguments
	LD	HL,0E000H	; pt to protected memory block
	LD	BC,1000H	; and length
	LD	A,(ARGV0)	; get argument
	OR	A		; flags
	JP	M,ARGERR	; error if neg
	JP	Z,ARGERR	; error if zero
	CP	4		; error if 
	JP	P,ARGERR	; more than 4 (1,2,3 are only allowed)
	LD	(NVRFLG),A	; save flag
ML10	LD	A,(NVRFLG)	; get it from memory
	CP	3		; see if LSBY
	JR	Z,ML40		; jump if so
	LD	E,55H		; get 55 for type 1
	CP	1		; see if it
	JR	Z,ML30		; jump and skip if so
	LD	E,0AAH		; else type 2
ML30	LD	(HL),E		; save char
	INC	HL		; inc ptr
	DEC	BC		; dec ctr
	LD	A,B		; get B
	OR	C		; or with C
	JR	NZ,ML30		; continue if not zero
 	RET			; that's all
ML40	LD	(HL),L		; save LSBYTE
	INC	HL		; int ptr
	DEC	BC		; dec ctr
	LD	A,B		; get B
	OR	C		; or with C
	JR	NZ,ML40		; continue if not zero
 	RET

MT	; memory NV test
	CALL	CRLF		; CRLFs
	CALL	CRLF
	LD	HL,MTM5		; pt to interation msg
	CALL	PUTS		; show it
	LD	HL,(NVRCTR)	; get iteration ctr
	CALL	PHL		; print it
	LD	HL,MTM6		; pt to failure msg
	CALL	PUTS		; show it
	LD	HL,(NVRFAL)	; get failure ctr
	CALL	PHL		; print it
	CALL	CRLF		; CRLFs
	CALL	CRLF
	LD	HL,(NVRCTR)	; get iteration ctr
	INC	HL		; inc it
	LD	(NVRCTR),HL	; save it
	LD	HL,0E000H	; pt to beginning of protected mem
	LD	BC,1000H	; and length
	LD	A,(NVRFLG)	; get old flag
	OR	A		; flags to check for errors
	JR	Z,MT40		; error if zero
	JP	M,MT40		; error if neg
	CP	4		; error if
	JP	P,MT40		; not 1, 2 or 3
	CP	3		; see if LSBY test
	JR	Z,MT30		; jump if so
	LD	E,55H		; assume type 1 (55)
	CP	1		; see if so
	JR	Z,MT10		; jump if so
	LD	E,0AAH		; else type 2 (aa)
MT10	LD	A,(HL)		; get old data
	CP	E		; see if same as should be
	JR	NZ,MT50		; jump if not
	INC	HL		; inc ptr
	DEC	BC		; dec ctr
	LD	A,B		; get B
	OR	C		; or with C
	JR	NZ,MT10		; continue if not zero
	JR	MT60		; else done and OK
MT30	LD	E,L		; LSBY test, get LSBYTE
	LD	A,(HL)		; get from memory
	CP	E		; see if same
	JR	NZ,MT50		; error if not, jump
	INC	HL		; inc ptr
	DEC	BC		; dec ctr
	LD	A,B		; get B
	OR	C		; or with C
	JR	NZ,MT30		; continue if not zero
	JR	MT60		; else done and OK
MT40	LD	HL,MTM1		; get bad type message
	CALL	PUTS		; put it
	LD	A,3
	LD	(NVRFLG),A	; force to type 3
	JP	ML10		; reload
MT50	PUSH	AF		; save char from memory
	PUSH	HL		; save address ptr
	LD	HL,MTM2		; pt to error msg
	CALL	PUTS		; print it
	POP	HL		; restore address ptr
	CALL	PHL		; print it
	LD	HL,MTM3		; pt to 'should be' msg
	CALL	PUTS		; print it
	LD	A,E		; get expected value
	CALL	PHXBYTE		; print it
	LD	HL,MTM4		; pt to 'was' msg
	CALL	PUTS		; print it
	POP	AF		; restore was value
	CALL	PHXBYTE		; print it
	CALL	CRLF		; CRLFs
	CALL	CRLF
	LD	HL,(NVRFAL)	; get error ctr
	INC	HL		; inc it
	LD	(NVRFAL),HL	; save it
	JP	ML10		; reload values
MT60	RET			; that's all
MTM1	DB	'bad type ',NULL
MTM2	DB	'error at:  ',NULL
MTM3	DB	', should be:  ',NULL
MTM4	DB	', was:  ',NULL
MTM5	DB	'iteration:  ',NULL
MTM6	DB	', failures:  ',NULL
