
ARGERR	; print	argument error
	LD	HL,MSGARGE		; ptr to message
	CALL	PUTS			; send the line
	RET

BCZSETC	; if BC	== 0, then set C
	LD	A,B			; get B
	OR	C			; or with C
	RET	NZ			; CY = 0, ret if not zero
	SCF				; else CY = 1, and
	RET				; ret

BSUM	; calculate sum of bytes from program start (CODEBAS)
	; to end of prgram (ENDCODE) inclusive
	LD	BC,ENDCODE-CODEBAS	; get number of bytes to do
	INC	BC			; inclusive
	LD	D,0			; clear upper half
	LD	HL,0			; clear ACC
	LD	IY,CODEBAS		; set ptr to start
BSUM10	LD	E,(IY+0)		; get a byte
	ADD	HL,DE			; add it
	INC	IY			; inc ptr
	DEC	BC			; dec ctr
	LD	A,C		 	; get lsb of CTR
	OR	B			; or with msb of CTR
	JR	NZ,BSUM10		; continue if not zero
	RET

CARG	; collect up to	4 arguments
	CALL	ZARG			; zero arg memory
	CALL	GARG			; get an arg
	RET	Z			; return if no data
	LD	IY,ARGC			; point	to ARG count
	LD	(ARGV0),HL		; put in memory
	INC	(IY+0)			; inc counter
	RET	C			; return if line terminator
	CALL	GARG			; get an arg
	RET	Z			; return if no data
	LD	(ARGV1),HL		; put in memory
	INC	(IY+0)			; inc counter
	RET	C			; return if line terminator
	CALL	GARG			; get an arg
	RET	Z			; return if no data
	LD	(ARGV2),HL		; put in memory
	INC	(IY+0)			; inc counter
	RET	C			; return if line terminator
	CALL	GARG			; get an arg
	RET	Z			; return if no data
	LD	(ARGV3),HL		; put in memory
	INC	(IY+0)			; inc counter
	RET				; thats	all thats wanted

CHARHX	; convert ASCII	char to	hex, set CY if invalid
	CP	'0'
	JP	M,CHARH20		; fail if minus
	CP	'9'+1
	JP	P,CHARH10		; fail if pos
	SUB	'0'			; convert to hex
	RET
CHARH10	CP	'A'
	JP	M,CHARH20		; fail if minus
	CP	'F'+1
	JP	P,CHARH20		; fail if pos
	SUB	'A'-10			; convert to hex
	RET
CHARH20	XOR	A			; zero A
	SCF				; mark failure
	JP	ERR			; that's a fatal error

CHARINT	; convert ASCII	char to	4 bit integer
	CP	'0'
	JP	M,CHARI10		; fail if minus
	CP	'9'+1
	JP	P,CHARI10		; fail if pos
	SUB	'0'			; convert to hex
	OR	A			; ensure CY is clear
	RET
CHARI10	XOR	A			; zero A
	SCF				; mark failure
	RET

COMP	; compare HL with DE, flags=Z if same
	LD	A,H			; get H
	CP	D			; compare with D
	RET	NZ			; ret if not same
	LD	A,L			; get E
	CP	E			; compare with E
	RET

CRLF	; print	CR and LF
	LD	A,ACR
	CALL	PUTCHAR
	LD	A,ALF
	CALL	PUTCHAR
	RET

DCPUR	; display CPU registers
	; print	registers here
	CALL	DREG			; show the registers
	LD	HL,DCPLAB
	CALL	PUTS			; print	lables
	RET

DELAY	; delay number of 100 milli-seconds stored in DE
	PUSH	HL			; save HL
	PUSH	DE			; move value
	POP	BC			; to BC
	LD	HL,3145			; get enough for 1/10 second
DELAY10	CALL	KILTIME
	CALL	KILTIME
	CALL	KILTIME
	DEC	BC			; dec the counter
	CALL	BCZSETC			; set C if zero
	JR	NC,DELAY10		; continue looping if not
	POP	HL			; restore hl
	RET				; and return

;DELAY01	; delay one unit
;	PUSH	HL			; save HL on stack
;	LD	HL,1000			; get delay value
;	JR	DELAY10			; jump to delay
;DELAY02	; delay two units
;	PUSH	HL			; save HL on stack
;	LD	HL,2000			; get delay value
;	JR	DELAY10			; jump to delay
;DELAY03	; delay three units
;	PUSH	HL			; save HL on stack
;	LD	HL,4000			; get delay value
;	JR	DELAY10			; jump to delay
;DELAY04	; delay four units
;	PUSH	HL			; save HL on stack
;	LD	HL,8000			; get delay value
;	JR	DELAY10			; jump to delay
;DELAY05	; delay four units
;	PUSH	HL			; save HL on stack
;	LD	HL,16000		; get delay value
;	JR	DELAY10			; jump to delay
;DELAY06	; delay four units
;	PUSH	HL			; save HL on stack
;	LD	HL,32000		; get delay value
;DELAY10	CALL	DELAY			; do the delay
;	POP	HL			; restore HL
;	RET
;
;DELAY	; delay the amount in HL
;	DEC	HL			; dec counter
;	LD	A,H			; move high to A
;	OR	L			; or in low
;	JR	NZ,DELAY		; loop if not zero
;	RET

DREG	; raw register dump
	LD	A,ACR			; get a CR
	CALL	PUTCHAR			; put to console
	LD	B,6			; number of space characaters
DREG10	LD	A,' '			; get a space
	CALL	PUTCHAR			; put it
	DJNZ	DREG10			; put them all
	LD	HL,ALOC			; point	to A reg
	CALL	PDATA			; print	it, and	point to I
	CALL	SPACE1
	LD	A,(FLOC)		; get flags
	CALL	PBIN			; show em
	CALL	SPACE1
	CALL	PDATA			; print	I
	LD	B,7			; 7 other 16 bit registers pairs
	LD	HL,BLOC			; point	to BC MSB
DREG30	PUSH	BC			; save count
	CALL	DRP1			; print	a 16 bit reg
	POP	BC			; restore count
	DJNZ	DREG30			; loop till done
	CALL	SPACE1
	LD	B,4
	LD	HL,(PLLOC)
DREG40	CALL	SPACE1
	CALL	PDATA
	DJNZ	DREG40
	CALL	CRLF			; print	a newline
	RET

DRP1	; do the dump of 16 bit	registers
	CALL	SPACE1			; space	over
	CALL	PDATA			; print	MS register
	DEC	HL			; restore HL
	DEC	HL			; print	LS register
	CALL	PDATA
	INC	HL			; point	to next	LSB
	INC	HL			; point	to next	MSB
	RET

DSPACE	; . char on B == 13,9,5
	LD	A,B			; get B
	CP	13
	JR	Z,B8SPA10
	CP	9
	JR	Z,B8SPA10
	CP	5
	JR	Z,B8SPA10
	LD	A,' '
	CALL	SPACE1			; normal spacing
	RET
B8SPA10	LD	A,' '			; print	two spaces
	CALL	SPACE2
	RET

ERR	; show an error	and recover
	LD	HL,ERRMSG		; point	to error msg
	CALL	PUTS			; put the string
	LD	SP,STK			; reload the stack
	JP	CMDLOOP			; jump to command interpreter

GARG	; get arg, Z= true if no input,	C = true if CR
	CALL	GETUCHE			; get a	char
	CP	ASPACE
	JR	Z,GARG			; do again if space
GARG05	LD	HL,0			; zero the value
	CP	ACR
	JR	NZ,GARG10		; jump if not CR
	SCF				; show CR and no input
	RET
GARG10	CALL	CHARHX			; convert to hex
	PUSH	AF			; save hex
	JR	NC,GARG20
	LD	HL,0			; if CY, then zero HL
GARG20	LD	B,4			; do 4 loops
GARG30	OR	A			; clear	CY
	LD	A,L
	RLA
	LD	L,A			; shift	L
	LD	A,H
	RLA
	LD	H,A			; shift	H
	DJNZ	GARG30			; do till done
	POP	AF			; restore hex
	OR	L			; or with L
	LD	L,A			; save in L
	CALL	GETUCHE			; get another char
	CP	ASPACE
	JR	NZ,GARG40
	INC	A			; space, show data and not CR
	RET
GARG40	CP	ACR
	JR	NZ,GARG10		; continue if not CR
	INC	A			; show data
	SCF				; and CR
	RET

GARGNSP	; get arg, don't allow leading spaces
	CALL	GETUCHE
	CP	ASPACE
	RET	Z
	JR	GARG05

GASCBY	; get ascii byte and add to checksum
	CALL	GETCHAR			; get MSByte
	CALL	MAPC
	CALL	CHARHX			; convert to HX
	RLCA
	RLCA
	RLCA
	RLCA				; put in MSB
	AND	0F0H			; mask
	LD	C,A			; save in C
	CALL	GETCHAR			; get LSByte
	CALL	MAPC
	CALL	CHARHX			; convert to HX
	AND	0FH			; mask
	OR	C			; or them together
	LD	C,A			; save it
	LD	A,(CKSUM)		; add to checksum
	ADD	A,C
	LD	(CKSUM),A
	LD	A,C			; restore to A
	RET

GETUCH	; get char, echo, convert to upper case
	CALL	GETCE			; get a	char with echo
	CALL	MAPC			; map chars as required
	RET

GETUCHE	; get char, convert LF to CR, convert to upper, and echo
	CALL	GETCE			; get a	char with echo
	CP	ALF
	JR	NZ,GETUC20		; jump if not LF
	LD	A,ACR			; convert to CR
	RET
GETUC20	CALL	MAPC			; map chars as required
	RET

HLATHL	; put value pointed at by HL into HL; don't hurt DE
	PUSH	DE			; save DE
	LD	E,(HL)			; get lsb
	INC	HL			; point	next
	LD	D,(HL)			; get msb
	PUSH	DE			; put to stack
	POP	HL			; and put in hl
	POP	DE			; restore DE
	RET

INCE	; increment the	E reg
	INC	E
	RET

KBPESC	; keyboard period or escape waiting?, CY=1 if true, CY=0 if not
	CALL	RBRDY			; uart receive buffer full?
	RET	NC			; ret if not
	CALL	GETCHAR			; get the char
	CP	AESC			; ESC?
	CALL	ZSETC			; set CY if match
	RET	C
	CP	'.'			; see if period
	CALL	ZSETC			; set CY if match
	RET


KILTIME	; kill time, value in HL
	; approx time is 6.5*HL	micro-seconds for 4 MHz	clock
	PUSH	HL			; save HL
	PUSH	AF			; save A
KILTI10	DEC	HL			; dec the count
	LD	A,L			; get L
	OR	H			; or with H
	JR	NZ,KILTI10		; loop till both are zero
	POP	AF			; restore A
	POP	HL			; restore HL
	RET

MAPC	; map chars as required
	CALL	MAPUC			; convert to uppercase
	CALL	MAPDLBS			; map delete to	back-space
	CALL	MAPLFCR			; map LF to CR
	RET

MAPDLBS	; map DEL to back-space
	CP	ADL			; see if delete
	RET	NZ			; ret if not
	LD	A,ABS			; else,	load BS
	RET

MAPLFCR	; map LF to CR
	CP	ALF			; see if LF
	RET	NZ			; ret if not
	LD	A,ACR			; else,	load CR
	RET

MAPUC	; map lc to upper case - data is in A
	CP	'a'
	RET	M			; ret if less than 'a'
	CP	'z'+1
	RET	P			; ret if greater than 'z'
	SUB	'a'-'A'			; map lower case to upper
	RET

MEMER1	; memory test error display routines
	LD	E,D			; save expected	in D
MEMER2	PUSH	AF			; save actual on stk
	PUSH	DE			; save expected	on stk
	PUSH	HL			; save addr on stk
	LD	HL,MERMSG		; pt to	error msg
	CALL	PUTS			; put the string
	POP	HL			; recover addr
	CALL	PHL			; print	it as word
	LD	HL,EXPMSG		; pt to	expected string
	CALL	PUTS			; print	it
	POP	AF			; recover expected
	CALL	PHXBYTE			; print	it as byte
	LD	HL,GOTMSG		; get got string
	CALL	PUTS			; print	it
	POP	AF			; recover actual
	CALL	PHXBYTE			; print	it as byte
	CALL	CRLF			; print	new line
	JP	CMDLOOP			; start	again and reset	stack
	RET				; return to monitor [NEVER EXECUTED]

MEMLD	; load memory with data	in E
	CALL	BCZSETC			; see if BC zero
	RET	C			; ret if so
	LD	(HL),E			; store	new data at HL
	INC	HL			; inc ptr
	DEC	BC			; dec ctr
	JR	MEMLD			; loop

MEMRD	; read memory and compare with data in D
	CALL	BCZSETC			; see if BC zero
	RET	C			; ret if so
	LD	A,(HL)			; get data from	HL
	CP	D			; compare with D
	JR	NZ,MEMER1		; error	if NZ
	INC	HL			; inc ptr
	DEC	BC			; dec ctr
	JR	MEMRD			; loop

MEMRWR	; read,	write and read memory
	CALL	BCZSETC			; see if BC zero
	RET	C			; ret if so
	LD	A,(HL)			; get data from	HL
	CP	D			; compare with D
	JR	NZ,MEMER1		; error	if NZ
	LD	(HL),E			; store	data
	LD	A,(HL)			; read data
	CP	E			; compare with E
	JR	NZ,MEMER2		; error	if NZ
	INC	HL			; inc ptr
	DEC	BC			; dec ctr
	JR	MEMRWR			; loop

MEMWLK	; memory walk of 1s
	LD	HL,(ARGV0)		; get start
	LD	BC,(ARGV2)		; get length
	CALL	MEMRWR			; read,	write and read
	LD	HL,MISC1		; pt to	new pattern
	LD	A,(HL)			; get it
	DEC	HL			; pt to	old
	LD	(HL),A			; make it so
	LD	D,A			; put old in D
	INC	HL			; pt to	new
	RLC	A			; rotate left
	LD	E,(HL)			; save as new in E
	LD	(HL),A			; and in mem
	RET

NZSETC	; if not zero set CY, else reset CY
	SCF				; set CY
	RET	NZ			; ret if NZ
	CCF				; must be zero so let CY = 0
	RET

ZSETC	; if zero set CY, else reset CY
	SCF				; set CY
	RET	Z			; ret if Z
	CCF				; must not be zero so let CY = 0
	RET

PADDR	; print	address
	LD	HL,(ARGV0)		; get value at ARGV0
	CALL	PHL			; print	it
	LD	A,':'			; follow with ':'
	CALL	PUTCHAR			; show it
	CALL	SPACE2			; space	it
	RET

PASBYTE	; print	a byte as ascii
	CP	' '
	JP	M,PASBY10		; jump if less than space
	CP	80H
	JP	M,PASBY20		; jump if printable
PASBY10	LD	A,'.'			; use '.' to show non-printable
PASBY20	CALL	PUTCHAR			; put the character
	RET

PASCII	; print	a byte as ASCII
	LD	A,(HL)			; get it
	INC	HL			; point	to next
	CALL	PASBYTE			; print	it
	RET

PBIN	; print	A as 8 bit binary number
	LD	E,A			; save data in E
	LD	B,8			; do 8 loops
PBIN10	RL	E			; shift	MSB to CY
	LD	A,'0'			; 0 is default
	JR	NC,PBIN20		; if CY	== 0 print 0
	LD	A,'1'			; else print 1
PBIN20	CALL	PUTCHAR
	DJNZ	PBIN10			; do all 8 bits
	RET

PDATA	; print	a byte
	LD	A,(HL)			; get it
	INC	HL			; point	to next
	CALL	PHXBYTE			; print	it
	RET

PEQUAL	; print	an equal sign
	LD	A,'='
	CALL	PUTCHAR
	CALL	SPACE1
	RET

PHL	; print	value in HL as hex
	LD	A,H
	CALL	PHXBYTE			; msb first
	LD	A,L
	CALL	PHXBYTE			; lsb next
	RET

PHXBYTE	; print	a hex byte
	PUSH	AF			; save the char
	RRCA
	RRCA
	RRCA
	RRCA				; move MSB to LSB
	CALL	PHXCHAR			; print	the char
	POP	AF			; restore char LSB
	CALL	PHXCHAR			; print	the char
	RET

PHXCHAR	; print	hex character
	AND	0FH			; only look at LSB
	CP	10			; >= 10?
	JP	P,PHXCH10		; jump if so
	ADD	A,'0'			; add '0' offset
	JR	PHXCH20			; skip whats next
PHXCH10	ADD	A,'A'-10		; adjust for alpha char
PHXCH20	CALL	PUTCHAR			; put the character
	RET

PLINE	; print	a display line
	PUSH	HL			; save it
	LD	HL,3206			; delay	20 character times at 9600
	CALL	KILTIME			; do the delay
	POP	HL			; restore HL
	CALL	CRLF			; start	new line
	CALL	PADDR			; print	the address
	LD	B,16			; number of bytes to show
PLINE10	CALL	PDATA			; show data
	CALL	DSPACE			; display spacing
	DJNZ	PLINE10			; loop
	CALL	SPACE2			; 2 spaces
	LD	HL,(ARGV0)		; reload pointer
	LD	B,16			; number of bytes to show
PLINE20	CALL	PASCII			; show it
	DJNZ	PLINE20			; loop
	LD	HL,(ARGV0)		; get start
	LD	DE,16
	ADD	HL,DE
	LD	(ARGV0),HL		; add 16 to it
	RET

POVT	; power on vector test
	LD	HL,(POVEC)		; get vector
	LD	DE,(POVECCK)		; and its supposed compliment
	LD	A,L			; get L
	OR	H			; or with H to see if zero
	RET	Z			; ret if so
	LD	A,L			; get L
	AND	H			; and with H to see if all ones
	CPL				; convert to zero if so
	OR	A			; set flags
	RET	Z			; ret if HL==FFFF
	LD	A,D			; else, get D
	CPL				; compliment it
	CP	H			; check with H
	RET	NZ			; ret if no match
	LD	A,E			; else, get E
	CPL				; compliment it
	CP	L			; check with L
	RET	NZ			; ret if no match
	LD	DE,0FFFFH		; init loop count
POVT10	CALL	KBPESC			; see if period or ESC
	RET	C			; return if true
;;;;;;;	CALL	GETCHAR			; get char
;;;;;;;	CP	'.'			; see if dot
;;;;;;;	RET	Z			; ret if so
	DEC	DE			; else, dec counter
	LD	A,D			; get D
	OR	E			; or with E
	JR	NZ,POVT10		; continue if both not zero
	LD	HL,(POVEC)		; else, timeout, get vector
	JP	(HL)			; and jump there

PROMPT	; print	the prompt
	LD	HL,MSGPRMT		; point	to message
	CALL	PUTS			; put it
	RET

PUTS	; put the string
	LD	A,(HL)			; get a	char
	INC	HL			; p++
	OR	A			; flags
	RET	Z			; done if NULL
	CALL	PUTCHAR			; put the char
	JR	PUTS

RLINE	; get line, put	in memory, offset in ARG0
	; ret w/CY = 1 if error, Z = 1 if length zero
	CALL	GETCHAR			; get a	char
	CALL	MAPUC
	CP	':'
	JR	NZ,RLINE		; do again if not colon
	XOR	A			; zero Z
	LD	(CKSUM),A		; zero checksum
	CALL	GASCBY			; get ascii byte
	LD	B,A			; save it as length
	OR	A			; test for end of file
	JR	NZ,RLINE20		; jump if not end of file
					; end of file found
	LD	B,4			; get addr, type, and check
RLINE10	CALL	GASCBY			; get a	pair
	DJNZ	RLINE10			; loop
	PUSH	HL			; save HL
	LD	HL,15384		; timeout value
	CALL	KILTIME			; kill about 100 milli-seconds
	POP	HL
	IF	BIOUART
	ELSE				; do this only if not Bit uart
	CALL	RBRDY			; any data waiting?
	CALL	C,GETCHAR		; clear	any garbage characters
	ENDIF
	CALL	CRLF			; newline
	XOR	A			; Z=1
	RET				; thats	all
RLINE20	CALL	GASCBY			; get address MSB
	LD	D,A
	CALL	GASCBY
	LD	E,A			; get address LSB
	LD	HL,(ARGV0)		; get offset
	ADD	HL,DE			; add them, HL points to memory
	CALL	GASCBY			; get type and drop it
RLINE30	CALL	GASCBY			; get data byte
	LD	(HL),A			; save it
	INC	HL			; point	to next
	DJNZ	RLINE30			; loop till record done
	CALL	GASCBY			; get checksum
	LD	A,(CKSUM)		; recover checksum accumulator
	OR	A			; test for zero
	JP	NZ,ERR			; jump to error	if error
	LD	A,'.'			; get record OK	mark
	CALL	PUTCHAR			; put to terminal
	XOR	A			; zero A
	INC	A			; CY = 0, Z = 0
	RET

SPACE3	; print	some spaces
	CALL	SPACE1			; print	3 spaces
SPACE2	CALL	SPACE1			; print	2 spaces
SPACE1	LD	A,' '			; print	1 space	character
	CALL	PUTCHAR
	RET

V01GT	; CY = 1 if start > stop
	OR	A			; clear	CY
	LD	HL,(ARGV1)
	LD	DE,(ARGV0)
	SBC	HL,DE			; HL <-	HL - DE
	RET

ZARG	; zero the argument memory
	LD	B,ARGVT-ARGC		; number of bytes to zero
	LD	HL,ARGC			; point	to ARG memory
ZARG10	LD	(HL),0			; move a zero
	INC	HL			; p++
	DJNZ	ZARG10			; do till done
	RET
